
--[[Overview of the design of this file:

Each "offer" quest will be triggered by a ring click, a researcher button, or an in-game event
Clicking the "OK" button (whatever it's labeled) may move something forward
When the quest is complete, another window may pop up.
Clicking THAT "OK" button will trigger some other behavior, including possibly the display of the next quest in line.

In some cases, two or more "offer" or "continue" quest windows may trigger in a row (probably Jindall and April)

It'll be the same event handler doing the whole series, so the handler will have to react conditionally.

]]--

function MQuestFrame_OnLoad(self)
--not doing anything here
end

function MQuestFrame_OnShow()
	--if (MQuestFrameNpcNameText:GetText() == nAla) then
	--	local questPortraitName = nAla;
	--	if (questPortrait ~= 0) then
	--		MQuestFrame_ShowQuestPortrait(MQuestFrame, questPortraitName, -33, -62);
	--	else
	--		MQuestFrame_HideQuestPortrait();
	--	end
	--end
end

function showPortrait(num)
	MQuestFrame.portrait1:Hide();
	MQuestFrame.portrait2:Hide();
	MQuestFrame.portrait3:Hide();
	MQuestFrame.portrait4:Hide();
	MQuestFrame.portrait5:Hide();
	MQuestFrame.portrait6:Hide();
	MQuestFrame.portrait7:Hide();
	MQuestFrame.portrait8:Hide();
	MQuestFrame.portrait9:Hide();
	MQuestFrame.portrait10:Hide();
	MQuestFrame.portrait11:Hide();
	MQuestFrame.portrait12:Hide();
	MQuestFrame.portrait13:Hide();
	if num == 1 then
		--display the book
		MQuestFrame.portrait1:Show();
	elseif num == 2 then
		--display Axechewer
		MQuestFrame.portrait2:Show();
	elseif num == 3 then
		--display Apriloneil
		MQuestFrame.portrait3:Show();
	elseif num == 4 then
		--display Jindall
		MQuestFrame.portrait4:Show();
	elseif num == 5 then
		--display Aladriaa Horde
		MQuestFrame.portrait5:Show();
	elseif num == 6 then
		--display Aladriaa Alliance
		MQuestFrame.portrait6:Show();
	elseif num == 7 then
		--display Calliopeia Horde
		MQuestFrame.portrait7:Show();
	elseif num == 8 then
		--display Calliopeia Alliance
		MQuestFrame.portrait8:Show();
	elseif num == 9 then
		--display Azukk now Draenei
		MQuestFrame.portrait9:Show();
	elseif num == 10 then
		--display Librarian
		MQuestFrame.portrait10:Show();
	elseif num == 11 then
		--display Boss Gnome
		MQuestFrame.portrait11:Show();
	elseif num == 12 then
		--display Boss Goblin
		MQuestFrame.portrait12:Show();
	elseif num == 13 then
		--display Rhudoh now Tauren
		MQuestFrame.portrait13:Show();
	end
end

--One handler, differing only by the text displayed on the CLOSE button (Accept, Continue, Complete)

function AddToQuestWindow(who, qstatus, qtitle, qtoptxt, qbottxt, mats)
	--trace("launched AddToQuestWindow");
	HideUIPanel(MQuestFrame); -- in case it's still displayed from before
	HideUIPanel(MQLFrame); -- in case they had the log open when the quest needed to be displayed
	HideUIPanel(MQLLeftFrame);
	MQuestFrameNpcNameText:SetText(who); -- Who's giving the quest; common to all these types
	--set the mini portrait for the frame
	if ((who == nAla) and (UnitFactionGroup("player") == "Horde")) then
		--trace("should be showing the Horde version of Aladriaa's portrait")
		showPortrait(5);
	elseif ((who == nAla) and (UnitFactionGroup("player") == "Alliance")) then
		--trace("should be showing the Alliance version of Aladriaa's portrait")
		showPortrait(6);
	elseif ((who == nCal) and (UnitFactionGroup("player") == "Horde")) then
		--trace("should be showing the Horde version of Calliopeia's portrait")
		showPortrait(7);
	elseif ((who == nCal) and (UnitFactionGroup("player") == "Alliance")) then
		--trace("should be showing the Alliance version of Calliopeia's portrait")
		showPortrait(8);
	elseif (who == nAxe) then
		--trace("should be showing Axechewer's portrait")
		showPortrait(2);
	elseif (who == "Jindall") then
		--trace("should be showing Jindall's portrait")
		showPortrait(4);
	elseif (who == "Apriloneil") then
		--trace("should be showing Apriloneil's portrait")
		showPortrait(3);
	elseif (who == "Azukk") then
		--trace("should be showing Azukk's portrait")
		showPortrait(9);
	elseif (who == "Librarian Belleford") then
		--trace("should be showing the Librarian's portrait")
		showPortrait(10);
	elseif ((who == nIzu) and (UnitFactionGroup("player") == "Horde")) then
		--trace("should be showing the Alliance/Gnome version of the Boss portrait")
		showPortrait(11);
	elseif ((who == nIzu) and (UnitFactionGroup("player") == "Alliance")) then
		--trace("should be showing the Horde/Goblin version of the Boss portrait")
		showPortrait(12);
	elseif (who == "Rhudoh") then
		--trace("should be showing Rhudoh's portrait")
		showPortrait(13);
	else
		--use the default book icon
		showPortrait(1);
	end
	ShowUIPanel(MQuestFrame);
	--local material = MQuestFrame_GetMaterial(mats);
	--MQuestFrame_SetMaterial(MQuestFrame, material);
	--QuestFrame_HideQuestPortrait();
	--QuestFrame_ShowQuestPortrait(); -- fix this, make it more manual than QuestFrame.lua:399 looking up a quest ID to find the right icon
	--QuestFrame_SetTextColor(GreetingText, material); - can be sensitive to the material of the background
	if (qstatus == "intro") then
		MQuestFrameTitle:SetText(qtitle);
		MQuestFrameTopText:SetText(qtoptxt);
		MQuestFrameHorizontalBreak:Hide();
		MQuestFrameObjectives:Hide();
		MQuestFrameBottomText:SetText("");
		MQuestFrameOKButton:SetText("Continue");
		MQuestScrollFrameScrollBar:SetValue(0);
	elseif (qstatus == "offer") then
		MQuestFrameTitle:SetText(qtitle);
		MQuestFrameTopText:SetText(qtoptxt);
		MQuestFrameHorizontalBreak:Show();
		if (qbottxt == nil) then
			MQuestFrameObjectives:Hide();
			MQuestFrameBottomText:SetText("");
		else
			MQuestFrameObjectives:Show();
			MQuestFrameBottomText:SetText(qbottxt);
		end
		MQuestFrameOKButton:SetText("Accept");
		MQuestScrollFrameScrollBar:SetValue(0);
	elseif (qstatus == "complete") then
		MQuestFrameTitle:SetText(qtitle);
		MQuestFrameTopText:SetText(qtoptxt);
		if qbottxt then
			MQuestFrameObjectives:Show();
			MQuestFrameBottomText:SetText(qbottxt);
		else
			MQuestFrameObjectives:Hide();
			MQuestFrameBottomText:SetText("");
		end
		MQuestFrameOKButton:SetText("Complete");
	end
	--And show the appropriate large portraits
	if (who == nAla) then
		local questPortraitName = nAla;
		MQuestFrame_ShowQuestPortrait(MQuestFrame, questPortraitName, -33, -62);
	elseif (who == nIzu) then
		local questPortraitName = nIzu;
		MQuestFrame_ShowQuestPortrait(MQuestFrame, questPortraitName, -33, -62);
	else
		MQuestFrame_HideQuestPortrait();
	end
end

function AddToRankWindow(who, qtitle, qtoptxt, pname1, pname2, pname3, pname4)
	local qbottxt = "";
	--For the leadership ranking task at the end
	--After all quests are done, so don't need to worry about re-hiding some of these things except in INIT for researcher and testing toons
	--trace("launched AddToRankWindow");
	--Put the names on each line
	if ((pname1 ~= nil) and (pname2 ~= nil) and (pname3 ~= nil) and (pname4 ~= nil)) then
		qbottxt = pname1 .. ":\n\n" .. pname2 .. ":\n\n" .. pname3 .. ":\n\n" .. pname4 .. ":";
	elseif ((pname1 ~= nil) and (pname2 ~= nil) and (pname3 ~= nil) and (pname4 == nil)) then
		qbottxt = pname1 .. ":\n\n" .. pname2 .. ":\n\n" .. pname3 .. ":";
	elseif ((pname1 ~= nil) and (pname2 ~= nil) and (pname3 == nil) and (pname4 == nil)) then
		qbottxt = pname1 .. ":\n\n" .. pname2 .. ":";
	elseif ((pname1 ~= nil) and (pname2 == nil) and (pname3 == nil) and (pname4 == nil)) then
		qbottxt = pname1 .. ":";
	end
	HideUIPanel(MQuestFrame); -- in case it's still displayed from before
	ShowUIPanel(MSurveyFrame);
	MSurveyFrame.npc.text:SetText(who); -- Who's giving the quest;
	MSurveyFrameTitle:SetText(qtitle);
	MSurveyFrameTopText:SetText(qtoptxt);
	MSurveyFrameBottomText:SetText(qbottxt);
	MSurveyFrameObjectives:Hide();
	MSurveyFrameBotRightPatch:Hide();
	MSurveyFrameOKButton:SetText("Rank");
	MSurveyFrameOKButton:SetScript("OnClick", MQuestRankButtonHandler)
	MSurveyScrollFrameScrollBar:SetValue(0);
	if GetNumPartyMembers() >= 1 then
		MSurveyFrameVa1Text:SetText("1"); 	-- 1 other in the party, so 2, but one is the researcher, so only one option to vote for
		MSurveyFrame.va1:Show();
	end
	if GetNumPartyMembers() >= 2 then 		-- 2 others in the party, so 2x2
		MSurveyFrameVa2Text:SetText("2");
		MSurveyFrame.va2:Show();
		MSurveyFrameVb1Text:SetText("1");
		MSurveyFrame.vb1:Show();
		MSurveyFrameVb2Text:SetText("2");
		MSurveyFrame.vb2:Show();
	end
	if GetNumPartyMembers() >= 3 then 		-- 3 others in the party, so 3x3
		MSurveyFrameVa3Text:SetText("3");
		MSurveyFrame.va3:Show();
		MSurveyFrameVb3Text:SetText("3");
		MSurveyFrame.vb3:Show();
		MSurveyFrameVc1Text:SetText("1");
		MSurveyFrame.vc1:Show();
		MSurveyFrameVc2Text:SetText("2");
		MSurveyFrame.vc2:Show();
		MSurveyFrameVc3Text:SetText("3");
		MSurveyFrame.vc3:Show();
	end
	if GetNumPartyMembers() == 4 then		-- 4 others, full party, so 4x4
		MSurveyFrameVa4Text:SetText("4");
		MSurveyFrame.va4:Show();
		MSurveyFrameVb4Text:SetText("4");
		MSurveyFrame.vb4:Show();
		MSurveyFrameVc4Text:SetText("4");
		MSurveyFrame.vc4:Show();
		MSurveyFrameVd1Text:SetText("1");
		MSurveyFrame.vd1:Show();
		MSurveyFrameVd2Text:SetText("2");
		MSurveyFrame.vd2:Show();
		MSurveyFrameVd3Text:SetText("3");
		MSurveyFrame.vd3:Show();
		MSurveyFrameVd4Text:SetText("4");
		MSurveyFrame.vd4:Show();
	end
end

function MQuestRankButtonHandler() -- close the ranking frame, and report the player's rankings to the researcher
	if ((GetNumPartyMembers() == 2) and (SCrankA == SCrankB)) then
		AddToOverhead("Please assign a unique\n ranking to each party member\n(no duplicates)");
	elseif ((GetNumPartyMembers() == 3) and ((SCrankA == SCrankB) or (SCrankB == SCrankC) or (SCrankA == SCrankC))) then
		AddToOverhead("Please assign a unique\n ranking to each party member\n(no duplicates)");
	elseif ((GetNumPartyMembers() == 4) and ((SCrankA == SCrankB) or (SCrankB == SCrankC) or (SCrankC == SCrankD) or (SCrankA == SCrankC) or (SCrankA == SCrankD) or (SCrankB == SCrankD))) then
		AddToOverhead("Please assign a unique\n ranking to each party member\n(no duplicates)");
	else
		--if it hits this else, then the places assigned are unique, so OK to send results to researcher
		if (GetNumPartyMembers() == 1) then
			SCrankings = "| " .. SCchoiceA .. ":" .. SCrankA .. " |";
		elseif (GetNumPartyMembers() == 2) then
			SCrankings = "| " .. SCchoiceA .. ":" .. SCrankA .. " | " .. SCchoiceB .. ":" .. SCrankB .. " |";
		elseif (GetNumPartyMembers() == 3) then
			SCrankings = "| " .. SCchoiceA .. ":" .. SCrankA .. " | " .. SCchoiceB .. ":" .. SCrankB .. " | " .. SCchoiceC .. ":" .. SCrankC .. " |";
		elseif (GetNumPartyMembers() == 4) then
			SCrankings = "| " .. SCchoiceA .. ":" .. SCrankA .. " | " .. SCchoiceB .. ":" .. SCrankB .. " | " .. SCchoiceC .. ":" .. SCrankC .. " | " .. SCchoiceD .. ":" .. SCrankD .. " |";
		end
		SendAddonMessage("SCRANK", SCrankings, "PARTY")
		local output = "RANK#" .. UnitName("Player") .. "#" .. SCrankings .. "\r";
		sendToResearcherLogger(output);
		--trace("Closed the rank frame; here's where the report will show up");
		HideUIPanel(MSurveyFrame)
		MSurveyFrame.va1:Hide();
		MSurveyFrame.va2:Hide();
		MSurveyFrame.va3:Hide();
		MSurveyFrame.va4:Hide();
		MSurveyFrame.vb1:Hide();
		MSurveyFrame.vb2:Hide();
		MSurveyFrame.vb3:Hide();
		MSurveyFrame.vb4:Hide();
		MSurveyFrame.vc1:Hide();
		MSurveyFrame.vc2:Hide();
		MSurveyFrame.vc3:Hide();
		MSurveyFrame.vc4:Hide();
		MSurveyFrame.vd1:Hide();
		MSurveyFrame.vd2:Hide();
		MSurveyFrame.vd3:Hide();
		MSurveyFrame.vd4:Hide();
		SCchoiceA = "";
		SCchoiceB = "";
		SCchoiceC = "";
		SCchoiceD = "";
		table.remove(SCchoices, 1);
		table.remove(SCchoices, 2);
		table.remove(SCchoices, 3);
		table.remove(SCchoices, 4);
	end
end

function MQuestFrameCloseHandler() -- in here, have to specify action for each Accept/Complete button that gets pressed
-- may be no action in some cases, but should always close the window with HideUIPanel(MQuestFrame), and always send to researcher log
	--trace("hit the MQuestFrameCloseHandler");

	local achieveSound = 0;

	if ((SCcheckpoint == 60) and (GetSubZoneText() == "Violet Stand")) then
		--trace("Violet-q0aGiven");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q0a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q0a.Title, "PARTY");
		SCcheckpoint = 70;
		SCachieve(AchTxt.p1);
		achieveSound = 1;
		HideUIPanel(MQuestFrame); -- No quest frame following (no longer a q0a complete)

	elseif (SCcheckpoint == 100) then
		--trace("accepted the librarian's quest")
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1a.Title, "PARTY");
		SCCurrQuest = "q1a"
		SCcheckpoint = 110;
		HideUIPanel(MQuestFrame);

	elseif (SCcheckpoint == 120) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1a.Title, "PARTY");
		SCCurrQuest = "q1b";
		AddToQuestWindow(nAxe, "offer", q1b.Title, q1b.OffTop, q1b.OffBot);
		SCcheckpoint = 130;
		--Tracker: show text for quest 1b
		MarauderTracker.q1b.text:Show();

	elseif (SCcheckpoint == 130) then
		--trace("No action on closing q1bOffer - go kill critters");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1b.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1b.Title, "PARTY");
		SCcheckpoint = 140;
		HideUIPanel(MQuestFrame);

	elseif (SCcheckpoint == 150) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1b.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1b.Title, "PARTY");
		SCcheckpoint = 160;
		AddToQuestWindow(nAxe, "offer", q1c.Title, q1c.OffTop, q1c.OffBot);
		--Tracker: show text for quest 1c
		MarauderTracker.q1c.text:Show();

	elseif (SCcheckpoint == 160) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1c.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1c.Title, "PARTY");
		SCCurrQuest = "q1c";
		SCcheckpoint = 170;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 180) then
		--trace("Finished with merchants");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1c.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1c.Title, "PARTY");
		SCcheckpoint = 190;
		AddToQuestWindow(nAla, "offer", q1d.Title, q1d.OffTop, q1d.OffBot);
		--Tracker: show text for quest 1d
		MarauderTracker.q1d.text:Show();

	elseif (SCcheckpoint == 190) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1d.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1d.Title, "PARTY");
		SCCurrQuest = "q1d";
		HideUIPanel(MQuestFrame);
		popVote(); --the Voting graphic appears on the screen (SCcheckpoint updated in popVote() function)

	elseif (SCcheckpoint == 210) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1d.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1d.Title, "PARTY");
		SCcheckpoint = 220;
		AddToQuestWindow(nAla, "offer", q1e.Title, q1e.OffTop, q1e.OffBot);
		--Tracker: show text for quest 1e
		MarauderTracker.q1e.text:Show();

	elseif (SCcheckpoint == 220) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1e.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1e.Title, "PARTY");
		SCCurrQuest = "q1e";
		SCcheckpoint = 230;
		HideUIPanel(MQuestFrame); -- No quest frame following
		zapMeLater();

	elseif (SCcheckpoint == 240) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1e.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1e.Title, "PARTY");
		SCcheckpoint = 250;
		AddToQuestWindow(nAla, "offer", q1f.Title, q1f.OffTop, q1f.OffBot);
		--Tracker: show text for quest 1f
		MarauderTracker.q1f.text:Show();

	elseif (SCcheckpoint == 250) then
		--trace("Accepted the request to give the report");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1f.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1f.Title, "PARTY");
		SCCurrQuest = "q1f";
		SCcheckpoint = 260;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 270) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1f.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completd " .. q1f.Title, "PARTY");
		SCcheckpoint = 280;
		AddToQuestWindow("Rhudoh", "offer", q1g.Title, q1g.OffTop, q1g.OffBot);
		--Tracker: show text for quest 1g
		MarauderTracker.q1g.text:Show();

	elseif (SCcheckpoint == 280) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1g.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1g.Title, "PARTY");
		SCCurrQuest = "q1g";
		SCcheckpoint = 285;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 290) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1g.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1g.Title, "PARTY");
		SCcheckpoint = 300;
		AddToQuestWindow(nAla, "offer", q1h.Title, q1h.OffTop, q1h.OffBot)
		--Tracker: show text for quest 1h
		MarauderTracker.q1h.text:Show();

	elseif (SCcheckpoint == 300) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1h.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1h.Title, "PARTY");
		SCCurrQuest = "q1h"
		SCcheckpoint = 305;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 310) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1h.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1h.Title, "PARTY");
		SCcheckpoint = 320;
		AddToQuestWindow(nAla, "offer", q1i.Title, q1i.OffTop, q1i.OffBot);
		--Tracker: show text for quest 1i
		MarauderTracker.q1i.text:Show();

	elseif (SCcheckpoint == 320) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q1i.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q1i.Title, "PARTY");
		SCCurrQuest = "q1i";
		SCcheckpoint = 330;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 340) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q1i.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q1i.Title, "PARTY");
		SCcheckpoint = 350;
		AddToQuestWindow(nAla, "offer", q2a.Title, q2a.OffTop, q2a.OffBot);
		--Tracker: show text for quest 2a
		MarauderTracker.q2a.text:Show();

	elseif (SCcheckpoint == 350) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2a.Title, "PARTY");
		SCCurrQuest = "q2a";
		SCcheckpoint = 360;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 370) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2a.Title, "PARTY");
		SCcheckpoint = 380;
		AddToQuestWindow(nAla, "offer", q2b.Title, q2b.OffTop, q2b.OffBot);
		--Tracker: show text for quest 2b
		MarauderTracker.q2b.text:Show();

	elseif (SCcheckpoint == 380) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2b.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2b.Title, "PARTY");
		SCCurrQuest = "q2b";
		SCcheckpoint = 390;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 400) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2b.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2b.Title, "PARTY");
		SCcheckpoint = 410;
		AddToQuestWindow(nAla, "offer", q2c.Title, q2c.OffTop, q2c.OffBot);
		--Tracker: show text for quest 2c
		MarauderTracker.q2c.text:Show();

	elseif (SCcheckpoint == 410) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2c.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2c.Title, "PARTY");
		SCCurrQuest = "q2c";
		SCcheckpoint = 420;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 430) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2c.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2c.Title, "PARTY");
		SCcheckpoint = 440;
		AddToQuestWindow("Azukk", "offer", q2d.Title, q2d.OffTop, q2d.OffBot);
		--Tracker: show text for quest 2d
		MarauderTracker.q2d.text:Show();

	elseif (SCcheckpoint == 440) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2d.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2d.Title, "PARTY");
		SCCurrQuest = "q2d";
		SCcheckpoint = 450;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 470) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2d.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2d.Title, "PARTY");
		SCcheckpoint = 480;
		AddToQuestWindow("Azukk", "offer", q2e.Title, q2e.OffTop, q2e.OffBot);
		--Tracker: show text for quest 2e
		MarauderTracker.q2e.text:Show();

	elseif (SCcheckpoint == 480) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2e.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2e.Title, "PARTY");
		SCCurrQuest = "q2e";
		SCcheckpoint = 490;
		HideUIPanel(MQuestFrame);

	--moved this one to populate automatically at the end of the overhead text in the previous step
	elseif (SCcheckpoint == 500) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2e.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2e.Title, "PARTY");
		HideUIPanel(MQuestFrame);
		--then, after 5 second delay, display Jindall message in overhead
		AddToOverheadDelayed("<Jindall says> Welllll... maybe ye can be useful.\nHelp me kill these cursed turtles.\nFollow me.");

	elseif (SCcheckpoint == 510) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "continued quest " .. q2f.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "continued " .. q2f.Title, "PARTY");
		AddToQuestWindow("Jindall", "offer", q2f.Title, q2f.OffTop, q2f.OffBot)
		SCcheckpoint = 520;
		--Tracker: show text for quest 2f
		MarauderTracker.q2f.text:Show();

	elseif (SCcheckpoint == 520) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2f.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2f.Title, "PARTY");
		SCCurrQuest = "q2f";
		HideUIPanel(MQuestFrame);
		SCcheckpoint = 530;

	elseif (SCcheckpoint == 540) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2f.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2f.Title, "PARTY");
		SCcheckpoint = 550;
		AddToQuestWindow(nAla, "offer", q2g.Title, q2g.OffTop, q2g.OffBot);
		--Tracker: show text for quest 2g
		MarauderTracker.q2g.text:Show();

	elseif (SCcheckpoint == 550) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q2g.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q2g.Title, "PARTY");
		SCCurrQuest = "q2g";
		SCcheckpoint = 560;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 570) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q2g.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q2g.Title, "PARTY");
		SCcheckpoint = 580;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 590) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q3a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q3a.Title, "PARTY");
		SCCurrQuest = "q3a";
		SCcheckpoint = 600;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 610) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q3a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q3a.Title, "PARTY");
		SCcheckpoint = 620;
		AddToQuestWindow("Apriloneil", "offer", q3b.Title, q3b.OffTop, q3b.OffBot);
		--Tracker: show text for quest 3b
		MarauderTracker.q3b.text:Show();

	elseif (SCcheckpoint == 620) then
		--trace("Accept, head off to find the WUM");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q3b.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q3b.Title, "PARTY");
		SCCurrQuest = "q3b";
		SCcheckpoint = 630;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 640) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q3b.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q3b.Title, "PARTY");
		SCcheckpoint = 650;
		AddToQuestWindow(nAla, "offer", q3c.Title, q3c.OffTop, q3c.OffBot);
		--Tracker: show text for quest 3c
		MarauderTracker.q3c.text:Show();

	elseif (SCcheckpoint == 650) then
		--trace("Accept, headed off to get sharked");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q3c.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q3c.Title, "PARTY");
		SCCurrQuest = "q3c";
		SCcheckpoint = 660;
		HideUIPanel(MQuestFrame); -- No quest frame following, next step is combat driven

	elseif (SCcheckpoint == 690) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q3c.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q3c.Title, "PARTY");
		SCcheckpoint = 700;
		AddToQuestWindow(nAla, "offer", q3d.Title, q3d.OffTop, q3d.OffBot);
		--Tracker: complete quest 3d
		MarauderTracker.q3d.text:Show();

	elseif (SCcheckpoint == 700) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q3d.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q3d.Title, "PARTY");
		SCCurrQuest = "q3d";
		SCcheckpoint = 710;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 720) then
		--trace("Done with cutscene, got scroll, Aladriaa asks for final report");
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q3d.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q3d.Title, "PARTY");
		SCcheckpoint = 730;
		AddToQuestWindow(nAla, "offer", q3e.Title, q3e.OffTop, q3e.OffBot);
		--Tracker: show text for quest 3e
		MarauderTracker.q3e.text:Show();

	elseif (SCcheckpoint == 730) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q3e.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q3e.Title, "PARTY");
		SCCurrQuest = "q3e";
		SCcheckpoint = 740;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 750) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q3e.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q3e.Title, "PARTY");
		SCcheckpoint = 760;
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 790) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "accepted quest " .. q4a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "accepted " .. q4a.Title, "PARTY");
		SCCurrQuest = "Q4a"
		SCcheckpoint = 800;
		AddToOverhead(ScreenTxt.line0140); --biscuit eater
		HideUIPanel(MQuestFrame); -- No quest frame following

	elseif (SCcheckpoint == 830) then
		local output = "QOK#" .. UnitName("Player") .. "#" .. "completed quest " .. q4a.Title .. "\r";
		sendToResearcherLogger(output);
		SendAddonMessage("SCQUESTS", "completed " .. q4a.Title, "PARTY");
		SCcheckpoint = 840;
		HideUIPanel(MQuestFrame); -- no more quests
		SCachieve(AchTxt.p5);
		achieveSound = 1;
		--next advance is via Leadership ranking task which is started by researcher LDR button click
		--followed by the researcher END button
	end

	if (achieveSound == 0) then
		PlaySound("igQuestListComplete");
	end
end


--################################################
--The rest of this file is left over from the WoW quest frame... for hints on how to do things with materials and the portrait...


--KEEP THIS ONE AS ALTERED
--We're not using any actual NPCs for the portrait (and questnpc will be nil anyway), so change this to always use book icon
--This function did assign the QuestFrameNpcNameText:SetText(UnitName("questnpc")) -- remember I have to do this in AddToQuestWindow

--function QuestFrame_SetPortrait() -- manually set this one in xml
	--QuestFramePortrait:SetTexture("Interface\\AddOns\\Marauder\\Graphics\\UI-QuestLog-BookIcon");
--end

-- #######################################################################
-- QUEST FRAME REWARD
-- #######################################################################

function QuestFrameRewardPanel_OnShow()
	QuestFrameDetailPanel:Hide();
	QuestFrameGreetingPanel:Hide();
	QuestFrameProgressPanel:Hide();
	local material = QuestFrame_GetMaterial();
	QuestFrame_SetMaterial(QuestFrameRewardPanel, material);
	QuestFrameRewardPanelBotRight:SetTexture("Interface\\QuestFrame\\UI-QuestGreeting-BotRight-blank");
	QuestInfo_Display(QUEST_TEMPLATE_REWARD, QuestRewardScrollChildFrame, QuestFrameCompleteQuestButton, material);
	QuestRewardScrollFrameScrollBar:SetValue(0);
	--The talking head
	local questPortrait, questPortraitText, questPortraitName = GetQuestPortraitTurnIn(); -- another place to control the talking head display
	if (questPortrait ~= 0) then
		QuestFrame_ShowQuestPortrait(QuestFrame, questPortrait, questPortraitText, questPortraitName, -33, -62);
	else
		QuestFrame_HideQuestPortrait();
	end
end

function QuestRewardCancelButton_OnClick() -- we'll want to neuter this, since we will be hiding the Decline button
	DeclineQuest();
	PlaySound("igQuestCancel");
end

function QuestRewardCompleteButton_OnClick() -- we're not using any of this logic, so here's where to put what to do next -- logic based on completion check-marks?
	if ( QuestInfoFrame.itemChoice == 0 and GetNumQuestChoices() > 0 ) then -- we don't do this, but it shouldn't hurt to leave it
		QuestChooseRewardError();
	else
		local money = GetQuestMoneyToGet(); -- we're not rewarding either
		if ( money and money > 0 ) then
			QuestFrame.dialog = StaticPopup_Show("CONFIRM_COMPLETE_EXPENSIVE_QUEST");
			if ( QuestFrame.dialog ) then
				MoneyFrame_Update(QuestFrame.dialog:GetName().."MoneyFrame", money);
			end
		else
			GetQuestReward(QuestInfoFrame.itemChoice);
		end
	end
end



-- #######################################################################
-- QUEST FRAME PORTRAIT (the portrait to the right)
-- #######################################################################


function MQuestFrame_ShowQuestPortrait(parentFrame, name, x, y)
	--trace("entered the function MQuestFrame_ShowQuestPortrait");
	MQuestNPCModel.alaally:Hide()
	MQuestNPCModel.alahrd:Hide()
	MQuestNPCModel.izually:Hide()
	MQuestNPCModel.izuhrd:Hide()
	MQuestNPCModel:SetParent(parentFrame);
	MQuestNPCModel:ClearAllPoints();
	MQuestNPCModel:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT", x, y);
	MQuestNPCModel:Show();
	if ((UnitFactionGroup("player") == "Alliance") and (name == nAla)) then
		MQuestNPCModel.alaally:Show()
	elseif ((UnitFactionGroup("player") == "Horde") and (name == nAla)) then
		MQuestNPCModel.alahrd:Show()
	elseif ((UnitFactionGroup("player") == "Alliance") and (name == nIzu)) then
		MQuestNPCModel.izually:Show()
	elseif ((UnitFactionGroup("player") == "Horde") and (name == nIzu)) then
		MQuestNPCModel.izuhrd:Show()
	end

	if (name and name ~= "") then
		MQuestNPCModelNameplate:Show();
		MQuestNPCModelBlankNameplate:Hide();
		MQuestNPCModelNameText:Show();
		MQuestNPCModelNameText:SetText(name);
	else
		MQuestNPCModelNameplate:Hide();
		MQuestNPCModelBlankNameplate:Show();
		MQuestNPCModelNameText:Hide();
	end
end

function MQuestFrame_HideQuestPortrait()
	MQuestNPCModel:Hide();
	MQuestNPCModel.alaally:Hide()
	MQuestNPCModel.alahrd:Hide()
end


