-- #######################################################
function setupSlashCommands()
	-- Setup slash commands, intended as a support mechanism for development testing; none of these will be needed by players
	-- In the final playable version, none of these comands will show up when /SC is typed; researchers can look in this file
	SlashCmdList["MarauderCOMMAND"] = MarauderSlashFunction;
	SLASH_MarauderCOMMAND1 = "/SC";
end
-- #######################################################



-- #######################################################
-- Slash commands
-- #######################################################
-- NOTE: hints for the slash commands are not printed OnLoad.. researcher will know about /SC
function MarauderSlashFunction(msg)
	local MarauderFrame = _G["Marauder"];


	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	if (msg == nil or msg == "" or string.find(msg, "help") ~= nil) then
		trace("Marauder commands:");
		trace("  /SC resMode - enable participant researcher functions");
		trace("  /SC name#_______ - assign a name to the party");
		trace("  /SC clue#_______ - set the magic word");
		trace("  /SC status - send a message to all players to get SCCurrQuest and SCcheckpoint status");
		trace("  /SC questproof - run through the animation of all quest windows");
		trace("  /SC sewerkills - force completion of rat/frog kills task");

	end
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |


	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	str1tosearch = string.find(msg,"resMode");
	if (str1tosearch ~= nil) then
		-- Register the player as researcher
		SCisRes = 1; -- set this variable locally for checks on receiving messages
		SendAddonMessage("SRRv1", "Registering as researcher", "PARTY"); -- message not used, variable set based on sender
		--Also send a message to researcher logger here...

		-- Ensure button frame is visible
		MarauderRes:Show();
		--MarauderResVisible = true;
		MarauderAch:Show();
		AB1:Hide();
		AB2:Hide();
		AB3:Hide();
		AB4:Hide();
		AB5:Hide();
		AB6:Hide();
		AB7:Hide();
		AB8:Hide();
		AB9:Hide();
		AB13:Show();
		AB14:Show();
		AB15:Show();

		--Initialize researcher-only variables
		--SCVote1, SCVote2, SCVote3, SCVote4 = 0, 0, 0, 0; 			-- Party member tabard voting choices
		--SCZapped = 0; 												-- Only the first wrong emote starts the Zap cycle
		--SCZapPosition = 0; 											-- Checked during iteration of Zap cycle to move through party

	end; --of resMode slashcommand
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |



	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	str2tosearch = string.find(msg,"status");
	if (str2tosearch ~= nil) then
		--trace("Sending a request to all players to get SCCurrQuest and SCcheckpoint status...");
		SendAddonMessage("SRv1", "STATUS", "PARTY");
	end
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |


	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	str2tosearch = string.find(msg,"name");
	if (str2tosearch ~= nil) then
		--trace("Sending a message to all players to set the value of SCgroupname to the value typed in");
		local label, gpnm = strsplit("#", msg, 2);
		--print("split msg into " .. label .. " and " .. gpnm);
		SendAddonMessage("SRNAME", gpnm, "PARTY");
	end
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |

		-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	str2tosearch = string.find(msg,"clue");
	if (str2tosearch ~= nil) then
		--trace("Sending a message to all players to set the value of SCclue to the value typed in");
		local label, cluestring = strsplit("#", msg, 2);
		--print("split msg into " .. label .. " and " .. cluestring);
		local cluetosend = string.lower(cluestring);
		print("Set clue to: " .. cluetosend);
		SendAddonMessage("SRCLUE", cluetosend, "PARTY");
	end
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |



		-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	str3tosearch = string.find(msg,"questproof");
	if (str3tosearch ~= nil) then
		trace("Play animation sequence of all quest windows for text and layout proofing.");
		proofHandler();
	end
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |


	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
	str2tosearch = string.find(msg,"sewerkills");
	if (str2tosearch ~= nil) then
		--trace("Something went wrong with sewer kill task, don't want to wait for respawn... send message to force completion");
		SendAddonMessage("SRv1", "SEWERKILL", "PARTY");
	end
	-- | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |


end
-- #######################################################
